package com.example.hpclock;

import java.util.regex.Pattern;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.content.SharedPreferences.OnSharedPreferenceChangeListener;
import android.os.Bundle;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;

public class PrefActivity extends PreferenceActivity implements OnSharedPreferenceChangeListener{

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		getFragmentManager().beginTransaction()
		.replace(android.R.id.content, new PrefFragment())
		.commit();
	}

	
	@Override
	protected void onPause() {
		// unregister the preference change listener
		super.onPause();
		PreferenceManager.getDefaultSharedPreferences(this)
		.unregisterOnSharedPreferenceChangeListener(this);
	}


	@Override
	protected void onResume() {
		// register the preference change listener
		super.onResume();
		PreferenceManager.getDefaultSharedPreferences(this)
		.registerOnSharedPreferenceChangeListener(this);
		
	}


	@Override
	public void onSharedPreferenceChanged(SharedPreferences sharedPreferences, String key) {
		// signify to main program that a result has changed
		setResult(Activity.RESULT_OK);
		// check if the changed preference was valid
		if(key.equals("arduinoIP_preference"))
		{
			String ValidIpAddressRegex = "^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$";
			String IP = sharedPreferences.getString(key,null);
			if(!Pattern.matches(ValidIpAddressRegex, IP))
			{
				// not a valid IP address
		    	AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
		    	alertDialogBuilder
		    		.setTitle("Invalid IP address.")
		    		.setMessage("Please enter an IP address of the form #.#.#.#")
		    		.setCancelable(false)
		    		.setPositiveButton("OK",new DialogInterface.OnClickListener() {
						public void onClick(DialogInterface dialog,int id) {    				
							dialog.cancel();
						}
					});
					
		    	
		    	AlertDialog alertDialog = alertDialogBuilder.create();
				alertDialog.show();
				// reset value
				sharedPreferences.edit().putString(key, getString(R.string.arduinoIP_default)).commit();
			}
		}
		
	}
	

}
